from pathlib import Path
from common import apply_transforms, TEST_STRING
from lark import Lark
import lark


def tee(s):
    print(s)
    return s


parser = Lark(
    apply_transforms(
        "\n".join(
            [
                line
                for line in Path("./grammar.lark").read_text("utf-8").splitlines()
                if not line.strip().startswith("// ")
            ]
        )
    ),
    start="math",
    parser="lalr",
    debug=True
)

tree = parser.parse(TEST_STRING)

print(tree.pretty())

lark.tree.pydot__tree_to_png(tree, Path('./parse_tree_lark.png').resolve().__str__())